// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use Buildable;
use Container;
use MenuShell;
use PackDirection;
use Widget;
use ffi;
use gio;
use glib::object::Cast;
use glib::object::IsA;
use glib::signal::SignalHandlerId;
use glib::signal::connect_raw;
use glib::translate::*;
use glib_ffi;
use std::boxed::Box as Box_;
use std::fmt;
use std::mem::transmute;

glib_wrapper! {
    pub struct MenuBar(Object<ffi::GtkMenuBar, ffi::GtkMenuBarClass, MenuBarClass>) @extends MenuShell, Container, Widget, @implements Buildable;

    match fn {
        get_type => || ffi::gtk_menu_bar_get_type(),
    }
}

impl MenuBar {
    pub fn new() -> MenuBar {
        assert_initialized_main_thread!();
        unsafe {
            Widget::from_glib_none(ffi::gtk_menu_bar_new()).unsafe_cast()
        }
    }

    pub fn new_from_model<P: IsA<gio::MenuModel>>(model: &P) -> MenuBar {
        assert_initialized_main_thread!();
        unsafe {
            Widget::from_glib_none(ffi::gtk_menu_bar_new_from_model(model.as_ref().to_glib_none().0)).unsafe_cast()
        }
    }
}

impl Default for MenuBar {
    fn default() -> Self {
        Self::new()
    }
}

pub const NONE_MENU_BAR: Option<&MenuBar> = None;

pub trait MenuBarExt: 'static {
    fn get_child_pack_direction(&self) -> PackDirection;

    fn get_pack_direction(&self) -> PackDirection;

    fn set_child_pack_direction(&self, child_pack_dir: PackDirection);

    fn set_pack_direction(&self, pack_dir: PackDirection);

    fn connect_property_child_pack_direction_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId;

    fn connect_property_pack_direction_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId;
}

impl<O: IsA<MenuBar>> MenuBarExt for O {
    fn get_child_pack_direction(&self) -> PackDirection {
        unsafe {
            from_glib(ffi::gtk_menu_bar_get_child_pack_direction(self.as_ref().to_glib_none().0))
        }
    }

    fn get_pack_direction(&self) -> PackDirection {
        unsafe {
            from_glib(ffi::gtk_menu_bar_get_pack_direction(self.as_ref().to_glib_none().0))
        }
    }

    fn set_child_pack_direction(&self, child_pack_dir: PackDirection) {
        unsafe {
            ffi::gtk_menu_bar_set_child_pack_direction(self.as_ref().to_glib_none().0, child_pack_dir.to_glib());
        }
    }

    fn set_pack_direction(&self, pack_dir: PackDirection) {
        unsafe {
            ffi::gtk_menu_bar_set_pack_direction(self.as_ref().to_glib_none().0, pack_dir.to_glib());
        }
    }

    fn connect_property_child_pack_direction_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(self.as_ptr() as *mut _, b"notify::child-pack-direction\0".as_ptr() as *const _,
                Some(transmute(notify_child_pack_direction_trampoline::<Self, F> as usize)), Box_::into_raw(f))
        }
    }

    fn connect_property_pack_direction_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(self.as_ptr() as *mut _, b"notify::pack-direction\0".as_ptr() as *const _,
                Some(transmute(notify_pack_direction_trampoline::<Self, F> as usize)), Box_::into_raw(f))
        }
    }
}

unsafe extern "C" fn notify_child_pack_direction_trampoline<P, F: Fn(&P) + 'static>(this: *mut ffi::GtkMenuBar, _param_spec: glib_ffi::gpointer, f: glib_ffi::gpointer)
where P: IsA<MenuBar> {
    let f: &F = transmute(f);
    f(&MenuBar::from_glib_borrow(this).unsafe_cast())
}

unsafe extern "C" fn notify_pack_direction_trampoline<P, F: Fn(&P) + 'static>(this: *mut ffi::GtkMenuBar, _param_spec: glib_ffi::gpointer, f: glib_ffi::gpointer)
where P: IsA<MenuBar> {
    let f: &F = transmute(f);
    f(&MenuBar::from_glib_borrow(this).unsafe_cast())
}

impl fmt::Display for MenuBar {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "MenuBar")
    }
}
