// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use Buildable;
use Container;
use Widget;
use ffi;
use gdk;
use glib::object::Cast;
use glib::object::IsA;
use glib::signal::SignalHandlerId;
use glib::signal::connect_raw;
use glib::translate::*;
use glib_ffi;
use std::boxed::Box as Box_;
use std::fmt;
use std::mem::transmute;
use xlib;

glib_wrapper! {
    pub struct Socket(Object<ffi::GtkSocket, ffi::GtkSocketClass, SocketClass>) @extends Container, Widget, @implements Buildable;

    match fn {
        get_type => || ffi::gtk_socket_get_type(),
    }
}

impl Socket {
    pub fn new() -> Socket {
        assert_initialized_main_thread!();
        unsafe {
            Widget::from_glib_none(ffi::gtk_socket_new()).unsafe_cast()
        }
    }
}

impl Default for Socket {
    fn default() -> Self {
        Self::new()
    }
}

pub const NONE_SOCKET: Option<&Socket> = None;

pub trait GtkSocketExt: 'static {
    fn add_id(&self, window: xlib::Window);

    fn get_id(&self) -> xlib::Window;

    fn get_plug_window(&self) -> Option<gdk::Window>;

    fn connect_plug_added<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId;

    fn connect_plug_removed<F: Fn(&Self) -> bool + 'static>(&self, f: F) -> SignalHandlerId;
}

impl<O: IsA<Socket>> GtkSocketExt for O {
    fn add_id(&self, window: xlib::Window) {
        unsafe {
            ffi::gtk_socket_add_id(self.as_ref().to_glib_none().0, window);
        }
    }

    fn get_id(&self) -> xlib::Window {
        unsafe {
            ffi::gtk_socket_get_id(self.as_ref().to_glib_none().0)
        }
    }

    fn get_plug_window(&self) -> Option<gdk::Window> {
        unsafe {
            from_glib_none(ffi::gtk_socket_get_plug_window(self.as_ref().to_glib_none().0))
        }
    }

    fn connect_plug_added<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(self.as_ptr() as *mut _, b"plug-added\0".as_ptr() as *const _,
                Some(transmute(plug_added_trampoline::<Self, F> as usize)), Box_::into_raw(f))
        }
    }

    fn connect_plug_removed<F: Fn(&Self) -> bool + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(self.as_ptr() as *mut _, b"plug-removed\0".as_ptr() as *const _,
                Some(transmute(plug_removed_trampoline::<Self, F> as usize)), Box_::into_raw(f))
        }
    }
}

unsafe extern "C" fn plug_added_trampoline<P, F: Fn(&P) + 'static>(this: *mut ffi::GtkSocket, f: glib_ffi::gpointer)
where P: IsA<Socket> {
    let f: &F = transmute(f);
    f(&Socket::from_glib_borrow(this).unsafe_cast())
}

unsafe extern "C" fn plug_removed_trampoline<P, F: Fn(&P) -> bool + 'static>(this: *mut ffi::GtkSocket, f: glib_ffi::gpointer) -> glib_ffi::gboolean
where P: IsA<Socket> {
    let f: &F = transmute(f);
    f(&Socket::from_glib_borrow(this).unsafe_cast()).to_glib()
}

impl fmt::Display for Socket {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "Socket")
    }
}
